## rustc-1.78 1.78.0%2Bdfsg1ubuntu1~bpo0

=== src/llvm-project/lldb/unittests/CMakeLists.txt ===
add_custom_target(LLDBUnitTests)
set_target_properties(LLDBUnitTests PROPERTIES FOLDER "lldb tests")

add_dependencies(lldb-unit-test-deps LLDBUnitTests)

include_directories(${LLDB_SOURCE_ROOT})
include_directories(${LLDB_PROJECT_ROOT}/unittests)

if (CXX_SUPPORTS_SUGGEST_OVERRIDE_FLAG)
  add_compile_options("-Wno-suggest-override")
endif()

function(add_lldb_unittest test_name)
  cmake_parse_arguments(ARG
    ""
    ""
    "LINK_LIBS;LINK_COMPONENTS"
    ${ARGN})

  if (NOT ${test_name} MATCHES "Tests$")
    message(FATAL_ERROR "Unit test name must end with 'Tests' for lit to find it.")
  endif()

  list(APPEND LLVM_LINK_COMPONENTS ${ARG_LINK_COMPONENTS})

  add_unittest(LLDBUnitTests
    ${test_name}
    ${ARG_UNPARSED_ARGUMENTS}
    )

  add_custom_command(
    TARGET ${test_name}
    POST_BUILD
    COMMAND "${CMAKE_COMMAND}" -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}/Inputs)

  target_link_libraries(${test_name} PRIVATE ${ARG_LINK_LIBS})
endfunction()

function(add_unittest_inputs test_name inputs)
  foreach (INPUT ${inputs})
    add_custom_command(
      TARGET ${test_name}
      POST_BUILD
      COMMAND "${CMAKE_COMMAND}" -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Inputs/${INPUT} ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}/Inputs
      COMMENT "Copying ${INPUT} to binary directory.")
  endforeach()
endfunction()

add_subdirectory(TestingSupport)
if (NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
  # FIXME: APITests.exe is not a valid googletest binary.
  add_subdirectory(API)
endif()
add_subdirectory(Breakpoint)
add_subdirectory(Core)
add_subdirectory(DataFormatter)
add_subdirectory(Disassembler)
add_subdirectory(Editline)
add_subdirectory(Expression)
add_subdirectory(Host)
add_subdirectory(Interpreter)
add_subdirectory(Instruction)
add_subdirectory(Language)
add_subdirectory(ObjectFile)
add_subdirectory(Platform)
add_subdirectory(Process)
add_subdirectory(ScriptInterpreter)
add_subdirectory(Signals)
add_subdirectory(Symbol)
add_subdirectory(SymbolFile)
add_subdirectory(Target)
add_subdirectory(tools)
add_subdirectory(UnwindAssembly)
add_subdirectory(Utility)
add_subdirectory(Thread)

if(LLDB_CAN_USE_DEBUGSERVER AND LLDB_TOOL_DEBUGSERVER_BUILD AND NOT LLDB_USE_SYSTEM_DEBUGSERVER)
  add_subdirectory(debugserver)
endif()

=== debian/changelog ===
rustc-1.78 (1.78.0+dfsg1ubuntu1~bpo0-0ubuntu0.20.04) focal; urgency=medium

  * Backport to Focal (LP: #2075108)
    - d/p/ubuntu-backport-disable-newer-tests.patch: add a patch to disable
      newer tests that can't pass on older Ubuntu series
    - d/p/ubuntu-jammy-skip-gdb-tests-on-armhf.patch: add a patch to
      disable gdb tests on armhf
    - Re-enable libgit2 vendoring:
      - d/control: remove libgit2-dev and libhttp-parser-dev from B-D
    - Re-enable LLVM vendoring (LLVM 18.1.2)
    - d/control: Comment out the Vendored-Sources-Rust support as it's
      not available in older releases
    - d/control: revert pkgconf to pkg-config
    - d/p/build/d-bootstrap-disable-git.patch: fix the patch so that version
      information is still included correctly when building under
      Debian or Ubuntu
    - Downgrade debhelper requirements and adapt the build files to
      older debhelper standards
    - d/control: Use cmake-mozilla instead of cmake on Focal
    - d/p/ubuntu-llvm-riscv-disable-zicsr.patch: fix build on RISC-V

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 15 Aug 2024 20:11:23 -0600

rustc-1.78 (1.78.0+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.78.0 (LP: #2075108)
    - d/control{,.in}: rename to rust-1.78 and re-generate
    - d/p/ubuntu/ubuntu-use-system-profiler-rt.patch: remove the patch as 
      we will use the upstream mechanism to specify the LLVM clang-rt
      instead of patching in a hardcoded one
    - d/p/ubuntu/ubuntu-add-s390x-allowed-features.patch: refresh the patch
    - d/copyright: remove unused vendored dependencies
    - d/copyright: update copyright data for vendored dependencies
    - d/p/ubuntu/ubuntu-vendor-no-workspace.patch: refresh patch
    - d/p/ubuntu/ubuntu-use-system-compiler-during-tests.patch: refresh the patch
    - d/s/lintian-overrides: re-generate for Rust 1.78
    - d/*: upgrade to LLVM 18.1
    - d/rules: adapt to changed docs install path
  * d/rules: add forced version check logic so that it will be difficult to
    screw up the version numbers when upgrading the package
  * d/rules: workaround path lookup issues with LLVM profiler runtime
  * d/rules: use upstream mechanism to specify LLVM clang-rt files
  * d/patches: synchronize patches from Debian
  * d/watch: get release information from GitHub but still download tarballs
    from Rust Forge
  * d/libstd-rust-1.76.lintian-overrides: remove auto-generated files
  * d/{rule,config.toml.in,README.source}: rename RUST_DESTDIR to RUST_BOOTSTRAP_DIR

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 25 Jul 2024 08:46:38 -0600

rustc-1.77 (1.77.2+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  [ Zixing Liu ]

  * New upstream release 1.77.2 (LP: #2070410)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.77
    - d/patches: remove obsoleted patches   
    - d/s/lintian-overrides*: update lintian overrides
    - d/control: update vendored crate list
  * d/p/ubuntu-add-s390x-allowed-features.patch: fix s390x build with backchain
  * d/tests: fix self-build tests when rust-defaults package does not point to
    the current versioned package
  * d/control: Build-Depends solely on versioned packages

  [ Fabian Grünbichler ]

  * config: don't attempt to optimize compiler-rt
  * update upstream unsuspicious files

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 08 Jul 2024 23:49:29 -0600

rustc-1.76 (1.76.0+dfsg0ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.76.0 (LP: #2052985)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.76
    - d/patches: remove obsoleted patches
    - d/s/lintian-overrides: update lintian overrides
    - d/control: update vendored crate list
    - d/p/ubuntu-upgrade-cc-to-1.0.85.patch: backport cc 1.0.85
    - d/p/d-0022-rust-by-example-strip-embedded-libs.patch: strip embedded
      CSS and JS libraries
    - d/p/d-bootstrap-cargo-doc-paths.patch: remove patch and build Cargo book
  * Remove libllvm17 dependency due to time_t transition renaming
  * d/p/ubuntu-skip-gdb-tests.patch: temporarily disables gdb tests to
    workaround test failures.
  * Transition Rust toolchain package to a versioned scheme (LP: #2054748)
    - d/*: move all the scripts to the <name>-X.Y.in format so that they
      are generated per version
    - d/rules: install files into their per-version directories
    - d/cargo-*: use a wrapper script to help cargo select the rustc binary
    - d/rules, d/cargo-X.Y.install.in: try to fix the installation logic
    - d/control.in: remove libllvm17 from B-D as it breaks the build after
      armhf time_t 64 bit transition
  * d/get-stage0.py: fix stage0 download
  * d/rules: add checks for checking source package
    - Re-generate auto-generated files if the input files are changed
    - Check if the source package name in the changelog is correct
    - Check and delete auto-generated files on dh_clean

 -- Zixing Liu <zixing.liu@canonical.com>  Fri, 07 Jun 2024 10:25:10 +0200

rustc (1.75.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.75.0 (LP: #2047858)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.75
    - d/patches: remove obsoleted patches
    - d/s/lintian-overrides: update lintian overrides
    - d/control: update vendored crate list

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 02 Jan 2024 12:09:03 -0700

rustc (1.74.1+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.74.1 (LP: #2044036)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/copyright: update the list of unused crates


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Let rustbuild control whether LLVM is compiled with debug symbols, rather
# than compiling with debug symbols unconditionally, which will fail on
# 32-bit architectures
CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
export PKG_CONFIG = pkg-config
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

# autopkgtest-related logic
ifneq (,$(RUST_TEST_SELFBUILD))
RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
endif

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_BOOTSTRAP_DIR))
        RUST_LIBRARY_PATH := $(RUST_BOOTSTRAP_DIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_BOOTSTRAP_DIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

# List generated files
FILES_TO_PRECONFIGURE := $(wildcard debian/*.in)
FILES_TO_PRECONFIGURE_OUT := $(subst X.Y,$(RUST_VERSION),\
  $(filter-out debian/control,\
    $(patsubst %.in,%,$(FILES_TO_PRECONFIGURE))\
  )\
)
DEFINED_SRC_NAME = $(shell dpkg-parsechangelog -S Source)
DEFINED_SRC_VERSION = $(shell cut -f1 -d' ' < $(CURDIR)/version)

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

override_dh_clean: debian/control
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/preconfigure.stamp: $(FILES_TO_PRECONFIGURE) debian/changelog
ifneq ($(RUST_LONG_VERSION),$(DEFINED_SRC_VERSION))
	$(error Version is incorrect:\
	  Source: $(RUST_LONG_VERSION), expected $(DEFINED_SRC_VERSION). Please check d/changelog)
endif
ifneq ($(DEFINED_SRC_NAME),rustc-$(RUST_VERSION))
	$(error Source package name is incorrect:\

## rustc-1.78 1.78.0+dfsg1ubuntu1~bpo0

=== vendor/similar/Makefile ===
all: test

build:
	@cargo build --all-features

doc:
	@cargo doc --all-features

test:
	@cargo test
	@cargo test --all-features
	@cargo test --no-default-features
	@cargo test --no-default-features --features bytes

format:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all

format-check:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all -- --check

lint:
	@rustup component add clippy 2> /dev/null
	@cargo clippy

.PHONY: all doc test format format-check lint

=== tests/run-make-fulldeps/issue-19371/Makefile ===
include ../../run-make/tools.mk

# This test ensures that rustc compile_input can be called twice in one task
# without causing a panic.
# The program needs the path to rustc to get sysroot.

all:
	$(RUSTC) foo.rs
	$(call RUN,foo $(TMPDIR) $(RUSTC))

=== tests/run-make/extern-multiple-copies2/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) foo1.rs
	$(RUSTC) foo2.rs
	mkdir $(TMPDIR)/foo
	cp $(TMPDIR)/libfoo1.rlib $(TMPDIR)/foo/libfoo1.rlib
	$(RUSTC) bar.rs \
		--extern foo1=$(TMPDIR)/foo/libfoo1.rlib \
		--extern foo2=$(TMPDIR)/libfoo2.rlib

=== tests/run-make/issue-53964/Makefile ===
include ../tools.mk

all:
	$(RUSTC) panic.rs
	$(RUSTC) -C panic=abort --emit=obj app.rs -L $(TMPDIR)

=== tests/run-make/issue64319/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Different optimization levels imply different values for `-Zshare-generics`,
# so try out a whole bunch of combinations to make sure everything is compatible
all:
	# First up, try some defaults
	$(RUSTC) --crate-type rlib foo.rs
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=3

	# Next try mixing up some things explicitly
	$(RUSTC) --crate-type rlib foo.rs -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=no
	$(RUSTC) --crate-type rlib foo.rs -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=yes
	$(RUSTC) --crate-type rlib foo.rs -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=no
	$(RUSTC) --crate-type rlib foo.rs -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=yes

	# Now combine a whole bunch of options together
	$(RUSTC) --crate-type rlib foo.rs
	$(RUSTC) --crate-type dylib bar.rs
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=1
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=1 -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=1 -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=2
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=2 -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=2 -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=3
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=3 -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=3 -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=s
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=s -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=s -Z share-generics=yes
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=z
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=z -Z share-generics=no
	$(RUSTC) --crate-type dylib bar.rs -C opt-level=z -Z share-generics=yes

=== tests/run-make/native-link-modifier-bundle/Makefile ===
# ignore-cross-compile
# ignore-windows-msvc

include ../tools.mk

# We're using the llvm-nm instead of the system nm to ensure it is compatible
# with the LLVM bitcode generated by rustc.
# Except on Windows where piping/IO redirection under MSYS2 is wonky with llvm-nm.
ifndef IS_WINDOWS
NM = "$(LLVM_BIN_DIR)"/llvm-nm
else
NM = nm
endif

all: $(call NATIVE_STATICLIB,native-staticlib)
	# Build a staticlib and a rlib, the `native_func` symbol will be bundled into them
	$(RUSTC) bundled.rs --crate-type=staticlib --crate-type=rlib
	$(NM) $(TMPDIR)/libbundled.a | $(CGREP) -e "T _*native_func"
	$(NM) $(TMPDIR)/libbundled.a | $(CGREP) -e "U _*native_func"
	$(NM) $(TMPDIR)/libbundled.rlib | $(CGREP) -e "T _*native_func"
	$(NM) $(TMPDIR)/libbundled.rlib | $(CGREP) -e "U _*native_func"

	# Build a staticlib and a rlib, the `native_func` symbol will not be bundled into it
	$(RUSTC) non-bundled.rs --crate-type=staticlib --crate-type=rlib
	$(NM) $(TMPDIR)/libnon_bundled.a | $(CGREP) -ve "T _*native_func"
	$(NM) $(TMPDIR)/libnon_bundled.a | $(CGREP) -e "U _*native_func"
	$(NM) $(TMPDIR)/libnon_bundled.rlib | $(CGREP) -ve "T _*native_func"
	$(NM) $(TMPDIR)/libnon_bundled.rlib | $(CGREP) -e "U _*native_func"

	# Build a cdylib, `native-staticlib` will not appear on the linker line because it was bundled previously
	# The cdylib will contain the `native_func` symbol in the end
	$(RUSTC) cdylib-bundled.rs --crate-type=cdylib --print link-args | $(CGREP) -ve '-l[" ]*native-staticlib'
	$(NM) $(call DYLIB,cdylib_bundled) | $(CGREP) -e "[Tt] _*native_func"

	# Build a cdylib, `native-staticlib` will appear on the linker line because it was not bundled previously
	# The cdylib will contain the `native_func` symbol in the end
	$(RUSTC) cdylib-non-bundled.rs --crate-type=cdylib --print link-args | $(CGREP) -e '-l[" ]*native-staticlib'
	$(NM) $(call DYLIB,cdylib_non_bundled) | $(CGREP) -e "[Tt] _*native_func"

=== tests/run-make/no-builtins-lto/Makefile ===
include ../tools.mk

all:
	# Compile a `#![no_builtins]` rlib crate
	$(RUSTC) no_builtins.rs
	# Build an executable that depends on that crate using LTO. The no_builtins crate doesn't
	# participate in LTO, so its rlib must be explicitly linked into the final binary. Verify this by
	# grepping the linker arguments.
	$(RUSTC) main.rs -C lto --print link-args | $(CGREP) 'libno_builtins.rlib'

=== tests/run-make/raw-dylib-cross-compilation/Makefile ===
# Tests that raw-dylib cross compilation works correctly

# only-gnu
# needs-i686-dlltool
# needs-x86_64-dlltool

# i686 dlltool.exe can't product x64 binaries.
# ignore-i686-pc-windows-gnu

include ../tools.mk

all:
	# Build as x86 and make sure that we have x86 objects only.
	$(RUSTC) --crate-type lib --crate-name i686_raw_dylib_test --target i686-pc-windows-gnu lib.rs
	"$(LLVM_BIN_DIR)"/llvm-objdump -a $(TMPDIR)/libi686_raw_dylib_test.rlib > $(TMPDIR)/i686.objdump.txt
	$(CGREP) "file format coff-i386" < $(TMPDIR)/i686.objdump.txt
	$(CGREP) -v "file format coff-x86-64" < $(TMPDIR)/i686.objdump.txt
	# Build as x64 and make sure that we have x64 objects only.
	$(RUSTC) --crate-type lib --crate-name x64_raw_dylib_test --target x86_64-pc-windows-gnu lib.rs
	"$(LLVM_BIN_DIR)"/llvm-objdump -a $(TMPDIR)/libx64_raw_dylib_test.rlib > $(TMPDIR)/x64.objdump.txt
	$(CGREP) "file format coff-x86-64" < $(TMPDIR)/x64.objdump.txt
	$(CGREP) -v "file format coff-i386" < $(TMPDIR)/x64.objdump.txt

=== tests/run-make/rustdoc-io-error/Makefile ===
include ../tools.mk

# This test verifies that rustdoc doesn't ICE when it encounters an IO error
# while generating files. Ideally this would be a rustdoc-ui test, so we could
# verify the error message as well.

# ignore-windows
# The test uses `chmod`.

OUTPUT_DIR := "$(TMPDIR)/rustdoc-io-error"

# This test operates by creating a temporary directory and modifying its
# permissions so that it is not writable. We have to take special care to set
# the permissions back to normal so that it's able to be deleted later.
all:
	mkdir -p $(OUTPUT_DIR)
	chmod u-w $(OUTPUT_DIR)
	-$(shell $(RUSTDOC) -o $(OUTPUT_DIR) foo.rs)
	chmod u+w $(OUTPUT_DIR)
	exit $($(.SHELLSTATUS) -eq 1)

=== src/llvm-project/clang-tools-extra/clang-tidy/boost/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  support
  FrontendOpenMP
  )

add_clang_library(clangTidyBoostModule
  BoostTidyModule.cpp
  UseToStringCheck.cpp

  LINK_LIBS
  clangTidy
  clangTidyUtils

  DEPENDS
  omp_gen
  ClangDriverOptions
  )

clang_target_link_libraries(clangTidyBoostModule
  PRIVATE
  clangAST
  clangASTMatchers
  clangBasic
  clangLex
  )

=== src/llvm-project/lldb/unittests/Interpreter/CMakeLists.txt ===
add_lldb_unittest(InterpreterTests
  TestCommandPaths.cpp
  TestCompletion.cpp
  TestOptionArgParser.cpp
  TestOptionValue.cpp
  TestOptionValueFileColonLine.cpp
  TestRegexCommand.cpp

  LINK_LIBS
      lldbCore
      lldbHost
      lldbTarget
      lldbSymbol
      lldbUtility
      lldbUtilityHelpers
      lldbInterpreter
      lldbPluginPlatformMacOSX
      LLVMTestingSupport
)

=== src/llvm-project/lldb/test/API/commands/expression/persist_objc_pointeetype/Makefile ===
OBJC_SOURCES := main.m


LD_EXTRAS := -framework Foundation -framework CloudKit

include Makefile.rules

=== debian/changelog ===
rustc-1.78 (1.78.0+dfsg1ubuntu1~bpo0-0ubuntu0.22.04) jammy; urgency=medium

  * Backport to Jammy (LP: #2075108)
    - d/p/ubuntu-backport-disable-newer-tests.patch: add a patch to disable
      newer tests that can't pass on older Ubuntu series
    - d/p/ubuntu-jammy-skip-gdb-tests-on-armhf.patch: add a patch to
      disable gdb tests on armhf
    - Re-enable libgit2 vendoring:
      - d/control: remove libgit2-dev and libhttp-parser-dev from B-D
    - Re-enable LLVM vendoring (LLVM 18.1.2)
    - d/control: Comment out the Vendored-Sources-Rust support as it's
      not available in older releases
    - d/control: revert pkgconf to pkg-config
    - d/p/build/d-bootstrap-disable-git.patch: fix the patch so that version
      information is still included correctly when building under
      Debian or Ubuntu

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 15 Aug 2024 20:11:23 -0600

=== debian/control ===
Source: rustc-1.78
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
# dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.77 | cargo-1.78 <!pkg.rustc.dlstage0>,
 rustc-1.77 | rustc-1.78 <!pkg.rustc.dlstage0>,
 cmake (>= 3.20) | cmake3 (>= 3.20),
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libsqlite3-dev,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,7 @@
 
 # Defines DEB_*_RUST_TYPE triples
 include debian/architecture.mk
+# for dh_install substitution variable
 export DEB_HOST_RUST_TYPE
 
 # Let rustbuild control whether LLVM is compiled with debug symbols, rather

## rustc-1.78 1.78.0+dfsg1ubuntu1

=== tests/run-make/allocator-shim-circular-deps/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	rm -rf $(TMPDIR) && mkdir $(TMPDIR)
	$(RUSTC) my_lib.rs
	$(RUSTC) main.rs --test --extern my_lib=$(TMPDIR)/libmy_lib.rlib

=== tests/run-make/atomic-lock-free/Makefile ===
include ../tools.mk

# This tests ensure that atomic types are never lowered into runtime library calls that are not
# guaranteed to be lock-free.

all:
ifeq ($(UNAME),Linux)
ifeq ($(filter x86,$(LLVM_COMPONENTS)),x86)
	$(RUSTC) --target=i686-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=x86_64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter arm,$(LLVM_COMPONENTS)),arm)
	$(RUSTC) --target=arm-unknown-linux-gnueabi atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=arm-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=armv7-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=thumbv7neon-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter aarch64,$(LLVM_COMPONENTS)),aarch64)
	$(RUSTC) --target=aarch64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter mips,$(LLVM_COMPONENTS)),mips)
	$(RUSTC) --target=mips-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=mipsel-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter powerpc,$(LLVM_COMPONENTS)),powerpc)
	$(RUSTC) --target=powerpc-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=powerpc-unknown-linux-gnuspe atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=powerpc64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=powerpc64le-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter systemz,$(LLVM_COMPONENTS)),systemz)
	$(RUSTC) --target=s390x-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
endif

=== tests/run-make/compiler-lookup-paths/Makefile ===
include ../tools.mk

# ignore-wasm32 (need a C compiler)
# ignore-wasm64 (need a C compiler)

all: $(TMPDIR)/libnative.a
	mkdir -p $(TMPDIR)/crate
	mkdir -p $(TMPDIR)/native
	mv $(TMPDIR)/libnative.a $(TMPDIR)/native
	$(RUSTC) a.rs
	mv $(TMPDIR)/liba.rlib $(TMPDIR)/crate
	$(RUSTC) b.rs -L native=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) b.rs -L dependency=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) b.rs -L crate=$(TMPDIR)/crate
	$(RUSTC) b.rs -L all=$(TMPDIR)/crate
	$(RUSTC) c.rs -L native=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) c.rs -L crate=$(TMPDIR)/crate && exit 1 || exit 0
	$(RUSTC) c.rs -L dependency=$(TMPDIR)/crate
	$(RUSTC) c.rs -L all=$(TMPDIR)/crate
	$(RUSTC) d.rs -L dependency=$(TMPDIR)/native && exit 1 || exit 0
	$(RUSTC) d.rs -L crate=$(TMPDIR)/native && exit 1 || exit 0
	$(RUSTC) d.rs -L native=$(TMPDIR)/native
	$(RUSTC) d.rs -L all=$(TMPDIR)/native
	# Deduplication tests:
	#   Same hash, no errors.
	mkdir -p $(TMPDIR)/e1
	mkdir -p $(TMPDIR)/e2
	$(RUSTC) e.rs -o $(TMPDIR)/e1/libe.rlib
	$(RUSTC) e.rs -o $(TMPDIR)/e2/libe.rlib
	$(RUSTC) f.rs -L $(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2
	#   Different hash, errors.
	$(RUSTC) e2.rs -o $(TMPDIR)/e2/libe.rlib
	$(RUSTC) f.rs -L $(TMPDIR)/e1 -L $(TMPDIR)/e2 && exit 1 || exit 0
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L $(TMPDIR)/e2 && exit 1 || exit 0
	$(RUSTC) f.rs -L crate=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2 && exit 1 || exit 0
	#   Native/dependency paths don't cause errors.
	$(RUSTC) f.rs -L native=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L dependency=$(TMPDIR)/e1 -L $(TMPDIR)/e2
	$(RUSTC) f.rs -L dependency=$(TMPDIR)/e1 -L crate=$(TMPDIR)/e2

=== tests/run-make/fpic/Makefile ===
# ignore-cross-compile
include ../tools.mk

# ignore-windows
# ignore-macos

# Test for #39529.
# `-z text` causes ld to error if there are any non-PIC sections

all:
	$(RUSTC) hello.rs -C link-args=-Wl,-z,text

=== tests/run-make/issue-37839/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) a.rs && $(RUSTC) b.rs
	$(BARE_RUSTC) c.rs -L dependency=$(TMPDIR) --extern b=$(TMPDIR)/libb.rlib \
		--out-dir=$(TMPDIR)

=== tests/run-make/simd-ffi/Makefile ===
include ../tools.mk

TARGETS =
ifeq ($(filter arm,$(LLVM_COMPONENTS)),arm)
# construct a fairly exhaustive list of platforms that we
# support. These ones don't follow a pattern
TARGETS += arm-linux-androideabi arm-unknown-linux-gnueabihf arm-unknown-linux-gnueabi
endif

ifeq ($(filter x86,$(LLVM_COMPONENTS)),x86)
X86_ARCHS = i686 x86_64
else
X86_ARCHS =
endif

# these ones do, each OS lists the architectures it supports
LINUX=$(filter aarch64 mips,$(LLVM_COMPONENTS)) $(X86_ARCHS)
ifeq ($(filter mips,$(LLVM_COMPONENTS)),mips)
LINUX += mipsel
endif

WINDOWS=$(X86_ARCHS)
# fails with: failed to get iphonesimulator SDK path: no such file or directory
#IOS=i386 aarch64 armv7
DARWIN=$(X86_ARCHS)

$(foreach arch,$(LINUX),$(eval TARGETS += $(arch)-unknown-linux-gnu))
$(foreach arch,$(WINDOWS),$(eval TARGETS += $(arch)-pc-windows-gnu))
#$(foreach arch,$(IOS),$(eval TARGETS += $(arch)-apple-ios))
$(foreach arch,$(DARWIN),$(eval TARGETS += $(arch)-apple-darwin))

all: $(TARGETS)

define MK_TARGETS
# compile the rust file to the given target, but only to asm and IR
# form, to avoid having to have an appropriate linker.
#
# we need some features because the integer SIMD instructions are not
# enabled by-default for i686 and ARM; these features will be invalid
# on some platforms, but LLVM just prints a warning so that's fine for
# now.
$(1): simd.rs
	$$(RUSTC) --target=$(1) --emit=llvm-ir,asm simd.rs \
                -C target-feature='+neon,+sse2' -C extra-filename=-$(1)
endef

$(foreach targetxxx,$(TARGETS),$(eval $(call MK_TARGETS,$(targetxxx))))

=== tests/run-make/stable-symbol-names/Makefile ===
include ../tools.mk

# The following command will:
#  1. dump the symbols of a library using `nm`
#  2. extract only those lines that we are interested in via `grep`
#  3. from those lines, extract just the symbol name via `sed`, which:
#    * always starts with "_ZN" and ends with "E" (`legacy` mangling)
#    * always starts with "_R" (`v0` mangling)
#  4. sort those symbol names for deterministic comparison
#  5. write the result into a file

dump-symbols = nm "$(TMPDIR)/lib$(1).rlib" \
             | grep -E "$(2)" \
             | sed -E "s/.*(_ZN.*E|_R[a-zA-Z0-9_]*).*/\1/" \
             | sort \
             > "$(TMPDIR)/$(1)$(3).nm"

# This test
# - compiles each of the two crates 2 times and makes sure each time we get
#   exactly the same symbol names
# - makes sure that both crates agree on the same symbol names for monomorphic
#   functions

all:
	$(RUSTC) stable-symbol-names1.rs
	$(call dump-symbols,stable_symbol_names1,generic_|mono_,_v1)
	rm $(TMPDIR)/libstable_symbol_names1.rlib
	$(RUSTC) stable-symbol-names1.rs
	$(call dump-symbols,stable_symbol_names1,generic_|mono_,_v2)
	cmp "$(TMPDIR)/stable_symbol_names1_v1.nm" "$(TMPDIR)/stable_symbol_names1_v2.nm"

	$(RUSTC) stable-symbol-names2.rs
	$(call dump-symbols,stable_symbol_names2,generic_|mono_,_v1)
	rm $(TMPDIR)/libstable_symbol_names2.rlib
	$(RUSTC) stable-symbol-names2.rs
	$(call dump-symbols,stable_symbol_names2,generic_|mono_,_v2)
	cmp "$(TMPDIR)/stable_symbol_names2_v1.nm" "$(TMPDIR)/stable_symbol_names2_v2.nm"

	$(call dump-symbols,stable_symbol_names1,mono_,_cross)
	$(call dump-symbols,stable_symbol_names2,mono_,_cross)
	cmp "$(TMPDIR)/stable_symbol_names1_cross.nm" "$(TMPDIR)/stable_symbol_names2_cross.nm"

=== tests/run-make/test-harness/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	# check that #[cfg_attr(..., ignore)] does the right thing.
	$(RUSTC) --test test-ignore-cfg.rs --cfg ignorecfg
	$(call RUN,test-ignore-cfg) | $(CGREP) 'shouldnotignore ... ok' 'shouldignore ... ignored'
	$(call RUN,test-ignore-cfg --quiet) | $(CGREP) -e "^i\.$$"
	$(call RUN,test-ignore-cfg --quiet) | $(CGREP) -v 'should'

=== debian/changelog ===
rustc-1.78 (1.78.0+dfsg1ubuntu1-0ubuntu0.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2075108)

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 15 Aug 2024 20:11:23 -0600

=== debian/control ===
--- 
+++ 
@@ -12,14 +12,18 @@
 Build-Depends:
  debhelper (>= 9),
  debhelper-compat (= 13),
-# dh-cargo (>= 28ubuntu1~),
+ dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo-1.77 | cargo-1.78 <!pkg.rustc.dlstage0>,
  rustc-1.77 | rustc-1.78 <!pkg.rustc.dlstage0>,
- cmake (>= 3.20) | cmake3 (>= 3.20),
+ llvm-18-dev:native,
+ llvm-18-tools:native,
+ libclang-rt-18-dev (>= 1:18.1.2),
+ libclang-common-18-dev (>= 1:18.1.2),
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
- pkg-config,
+ pkgconf,
 # this is sometimes needed by rustc_llvm
  zlib1g-dev:native,
  zlib1g-dev,
@@ -29,11 +33,10 @@
  bash-completion,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
  libssh2-1-dev,
+ libgit2-dev (>= 1.7.0),
+ libgit2-dev (<< 1.8~~),
+ libhttp-parser-dev,
  libsqlite3-dev,
-# Required for llvm build
- autotools-dev,
- m4,
- ninja-build,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
@@ -51,6 +54,7 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
+ clang-18:native,
  libssl-dev,
 Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -34,21 +34,38 @@
 # for dh_install substitution variable
 export DEB_HOST_RUST_TYPE
 
-# Let rustbuild control whether LLVM is compiled with debug symbols, rather
-# than compiling with debug symbols unconditionally, which will fail on
-# 32-bit architectures
-CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-
 # for dh_install substitution variable
 export RUST_LONG_VERSION
 export RUST_VERSION
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
+# Use system LLVM (comment out to use vendored LLVM)
+LLVM_VERSION = 18
+OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
+# used by the upstream profiler build script
+CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
+LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
+ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
+# Clang per-target layout
+export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
+else
+# Clang legacy layout
+CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
+ifeq ($(DEB_HOST_ARCH),armhf)
+CLANG_RT_ARCH := armhf
+endif
+export LLVM_PROFILER_RT_LIB := /../../usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
+endif
 # Cargo-specific flags
 export LIBSSH2_SYS_USE_PKG_CONFIG=1
-export PKG_CONFIG = pkg-config
+# Make it easier to test against a custom LLVM
+ifneq (,$(LLVM_DESTDIR))
+LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
+LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
+export LD_LIBRARY_PATH
+endif
+
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_HOST_ARCH),riscv64)
 NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -181,24 +198,3 @@
 DEFINED_SRC_VERSION = $(shell cut -f1 -d' ' < $(CURDIR)/version)
 
 %:
-	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion
-
-.PHONY: .dbg-windows
-.dbg-windows:
-	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)
-
-.PHONY: build
-build:
-	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion
-
-override_dh_clean: debian/control
-	# Upstream contains a lot of these
-	dh_clean -XCargo.toml.orig
-
-debian/preconfigure.stamp: $(FILES_TO_PRECONFIGURE) debian/changelog
-ifneq ($(RUST_LONG_VERSION),$(DEFINED_SRC_VERSION))
-	$(error Version is incorrect:\
-	  Source: $(RUST_LONG_VERSION), expected $(DEFINED_SRC_VERSION). Please check d/changelog)
-endif
-ifneq ($(DEFINED_SRC_NAME),rustc-$(RUST_VERSION))
-	$(error Source package name is incorrect:\
